#include "./H_Group/can.h"
bit B_Can1Send = 0;
bit B_Can1Read = 0;

CAN_DataDef CAN1_Tx;
CAN_DataDef CAN1_Rx[8];

bit can_send_dat_flag = 0;

unsigned char CanReadReg(unsigned char addr)
{
    CANAR = addr;
    return CANDR;
}

void CanWriteReg(unsigned char addr, unsigned char dat)
{
    CANAR = addr;
    CANDR = dat;
}

void CanSetBaudrate(void) // 500Kbps@52MHz
{
    CanWriteReg(MR, 0x04);   // ʹResetģʽ
    CanWriteReg(BTR0, 0xc3); // SJW(3), BRP(3)
    CanWriteReg(BTR1, 0xc6); // SAM(1), TSG2(4), TSG1(6)
    CanWriteReg(MR, 0x00);   // ˳Resetģʽ
}

void CanReadFifo(CAN_DataDef *CAN)
{
    u8 i;
    u8 pdat[5];
    u8 RX_Index = 0;

    pdat[0] = CanReadReg((u8)(RX_BUF0 + (RX_Index++ & 3)));

    if (pdat[0] & 0x80) // жǱ׼֡չ֡
    {
        pdat[1] = CanReadReg((u8)(RX_BUF0 + (RX_Index++ & 3))); // չ֡IDռ4ֽ
        pdat[2] = CanReadReg((u8)(RX_BUF0 + (RX_Index++ & 3)));
        pdat[3] = CanReadReg((u8)(RX_BUF0 + (RX_Index++ & 3)));
        pdat[4] = CanReadReg((u8)(RX_BUF0 + (RX_Index++ & 3)));
        CAN->ID = (((u32)pdat[1] << 24) + ((u32)pdat[2] << 16) + ((u32)pdat[3] << 8) + pdat[4]) >> 3;
    }
    else
    {
        pdat[1] = CanReadReg((u8)(RX_BUF0 + (RX_Index++ & 3))); // ׼֡IDռ2ֽ
        pdat[2] = CanReadReg((u8)(RX_BUF0 + (RX_Index++ & 3)));
        CAN->ID = ((pdat[1] << 8) + pdat[2]) >> 5;
    }

    CAN->FF = pdat[0] >> 7;  // ֡ʽ
    CAN->RTR = pdat[0] >> 6; // ֡
    CAN->DLC = pdat[0];      // ݳ

    for (i = 0; ((i < CAN->DLC) && (i < 8)); i++) // ȡݳΪlen಻8
    {
        CAN->DataBuffer[i] = CanReadReg((u8)(RX_BUF0 + (RX_Index++ & 3))); // ȡЧ
    }
    while (RX_Index & 3) // жѶݳǷ4
    {
        CanReadReg((u8)(RX_BUF0 + (RX_Index++ & 3))); // ȡݣһ֡ռ4ռ䣬㲹0
    }
}

u8 CanReadMsg(CAN_DataDef *CAN)
{
    u8 i;
    u8 n = 0;
    do
    {
        CanReadFifo(&CAN[n++]); // ȡջ
        i = CanReadReg(SR);
    } while (i & 0x80); // жϽջǷݣеĻȡ

    return n; // ֡
}

void CanSendMsg(CAN_DataDef *CAN)
{
    u32 CanID;
    u8 RX_Index, i;

    if (CANSEL == CAN1) // жǷCAN1
    {
        while (B_Can1Send)
            ; // ȴCAN1ϴη
    }

    if (CAN->FF) // жǷչ֡
    {
        CanID = CAN->ID << 3;
        CanWriteReg(TX_BUF0, CAN->DLC | ((u8)CAN->RTR << 6) | 0x80); // bit7: ׼֡(0)/չ֡(1), bit6: ֡(0)/Զ֡(1), bit3~bit0: ݳ(DLC)
        CanWriteReg(TX_BUF1, (u8)(CanID >> 24));
        CanWriteReg(TX_BUF2, (u8)(CanID >> 16));
        CanWriteReg(TX_BUF3, (u8)(CanID >> 8));
        CanWriteReg(TX_BUF0, (u8)CanID);

        RX_Index = 1;
        for (i = 0; ((i < CAN->DLC) && (i < 8)); i++) // ݳΪDLC಻8
        {
            CanWriteReg((u8)(TX_BUF0 + (RX_Index++ & 3)), CAN->DataBuffer[i]); // дЧ
        }
        while (RX_Index & 3) // жѶݳǷ4
        {
            CanWriteReg((u8)(TX_BUF0 + (RX_Index++ & 3)), 0x00); // дݣһ֡ռ4ռ䣬㲹0
        }
    }
    else // ͱ׼֡
    {
        CanID = (u16)(CAN->ID << 5);
        CanWriteReg(TX_BUF0, CAN->DLC | ((u8)CAN->RTR << 6)); // bit7: ׼֡(0)/չ֡(1), bit6: ֡(0)/Զ֡(1), bit3~bit0: ݳ(DLC)
        CanWriteReg(TX_BUF1, (u8)(CanID >> 8));
        CanWriteReg(TX_BUF2, (u8)CanID);

        RX_Index = 3;
        for (i = 0; ((i < CAN->DLC) && (i < 8)); i++) // ݳΪDLC಻8
        {
            CanWriteReg((u8)(TX_BUF0 + (RX_Index++ & 3)), CAN->DataBuffer[i]); // дЧ
        }
        while (RX_Index & 3) // жѶݳǷ4
        {
            CanWriteReg((u8)(TX_BUF0 + (RX_Index++ & 3)), 0x00); // дݣһ֡ռ4ռ䣬㲹0
        }
    }
    CanWriteReg(CMR, 0x04); // һ֡

    if (CANSEL == CAN1) // жǷCAN1
    {
        B_Can1Send = 1; // CAN1æ־
    }
}

void PortSwitch(void)
{
    P_SW1 &= ~0x30; // CAN1: CANRX(P0.0), CANTX(P0.1)
}

void Can_Init(void)
{
    CANEN = 1;     // CAN1ģ
    CANSEL = CAN1; // ѡCAN1ģ
    PortSwitch();
    CanSetBaudrate();
    CanWriteReg(MR, 0x05);                     // ʹResetģʽ˫˲
    CanWriteReg(ACR0, (u8)(User_Can_ID >> 3)); // մĴ,豸ID͹㲥ID
    CanWriteReg(ACR1, (u8)(User_Can_ID << 5));
    CanWriteReg(ACR2, 0x00); // 㲥ַĬΪ0Ҫ
    CanWriteReg(ACR3, 0x00);

    CanWriteReg(AMR0, 0x00); // μĴλУ飬RTRУ
    CanWriteReg(AMR1, 0x1f);
    CanWriteReg(AMR2, 0x00);
    CanWriteReg(AMR3, 0x1f);

    CanWriteReg(ISR, 0xff); // жϱ־
    CanWriteReg(IMR, 0xff); // жϼĴ,Ӧж
    CanWriteReg(MR, 0x00);  // ˳ Reset Mode
    CANICR |= 0x02;         // CAN1жʹ
}

void CANBUS1_Interrupt(void) interrupt CAN1_VECTOR
{
    u8 isr;
    u8 store;
    u8 arTemp;

    arTemp = CANAR; // CANARֳ棬ѭд CANAR жϣж޸ CANAR 
    store = AUXR2;  // AUXR2ֳ

    AUXR2 &= ~0x08; // ѡCAN1ģ
    isr = CanReadReg(ISR);

    if ((isr & 0x04) == 0x04) // TI
    {
        CANAR = ISR;
        CANDR = 0x04; // CLR FLAG

        B_Can1Send = 0;
    }
    if ((isr & 0x08) == 0x08) // RI
    {
        CANAR = ISR;
        CANDR = 0x08; // CLR FLAG

        B_Can1Read = 1;
    }

    if ((isr & 0x40) == 0x40) // ALI
    {
        CANAR = ISR;
        CANDR = 0x40; // CLR FLAG
    }

    if ((isr & 0x20) == 0x20) // EWI
    {
        CANAR = MR;
        CANDR &= ~0x04; //  Reset Mode, BUS-OFF״̬˳

        CANAR = ISR;
        CANDR = 0x20; // CLR FLAG
    }

    if ((isr & 0x10) == 0x10) // EPI
    {
        CANAR = ISR;
        CANDR = 0x10; // CLR FLAG
    }

    if ((isr & 0x02) == 0x02) // BEI
    {
        CANAR = ISR;
        CANDR = 0x02; // CLR FLAG
    }

    if ((isr & 0x01) == 0x01) // DOI
    {
        CANAR = ISR;
        CANDR = 0x01; // CLR FLAG
    }

    AUXR2 = store;  // AUXR2ֳָ
    CANAR = arTemp; // CANARֳָ
}

void Can_Dat_Handle(CAN_DataDef *can_dat)
{
    if (can_dat->DLC == 1) // ݳȱ1,fifoƵʳ˾Ͳտ
    {
        if (can_dat->ID == User_Can_ID) // ID,Ч
        {
            if (can_dat->RTR == 1)
            {
                can_send_dat_flag = 1;                                          // һݷ
                CAN1_Tx.FF = STANDARD_FRAME;                                    // ׼֡
                CAN1_Tx.RTR = 0;                                                // 0֡1Զ֡
                CAN1_Tx.DLC = 0x03;                                             // ݳ
                CAN1_Tx.ID = 0x0f;                                              // CAN ID,15
                CAN1_Tx.DataBuffer[0] = (u8)((int)(road.mroi) >> 8); // 
                CAN1_Tx.DataBuffer[1] = (u8)((int)(road.mroi));      // ݷΧ0~20000
                #ifdef LEFT
                CAN1_Tx.DataBuffer[2] = road.state|0x80;
                #endif
                #ifdef RIGHT
                CAN1_Tx.DataBuffer[2] = road.state;
                #endif
            }
            else
            {
                if (can_dat->DataBuffer[Dat_Ctrl] & Ctrl_ReRun)
                {
                    Re_Run_Flag = 1; // ֻ1
                }
                led_on_off = (can_dat->DataBuffer[Dat_Ctrl] & Ctrl_LED);
                if (can_dat->DataBuffer[Dat_Ctrl] & Ctrl_Auto)
                {
                    Start_Auto_Flag = 1;
                }
            }
        }
    }
}
