#include "./H_Group/eeprom.h"

void DisableEEPROM(void)
{
    IAP_CONTR = 0;    // ֹIAP
    IAP_CMD = 0;      // ȥIAP
    IAP_TRIG = 0;     // ֹIAP󴥷
    IAP_ADDRE = 0xff; // ַõ IAP 
    IAP_ADDRH = 0xff; // ַõ IAP 
    IAP_ADDRL = 0xff;
}

void EEPROM_Trig(void)
{
    F0 = EA; // ȫж
    EA = 0;  // ֹж, ⴥЧ
    IAP_TRIG = 0x5A;
    IAP_TRIG = 0xA5; // 5AHA5HIAPĴÿζҪ
                     // A5HIAP
                     // CPUȴIAPɺ󣬲Żִг
    _nop_();         // STC32FǶ༶ˮߵָϵͳ4NOP֤IAP_DATA׼
    _nop_();
    _nop_();
    _nop_();
    EA = F0; // ָȫж
}

void EEPROM_read_n(u32 EE_address, u8 *DataAddress, u16 number)
{
    IAP_ENABLE(); // õȴʱ䣬IAPһξ͹
    IAP_READ();   // ֽڶıʱ
    do
    {
        IAP_ADDRE = (u8)(EE_address >> 16); // ͵ַֽڣַҪıʱ͵ַ
        IAP_ADDRH = (u8)(EE_address >> 8);  // ͵ַֽڣַҪıʱ͵ַ
        IAP_ADDRL = (u8)EE_address;         // ͵ַֽڣַҪıʱ͵ַ
        EEPROM_Trig();                      // EEPROM
        *DataAddress = IAP_DATA;            // 
        EE_address++;
        DataAddress++;
    } while (--number);

    DisableEEPROM();
}

void EEPROM_SectorErase(u32 EE_address)
{
    IAP_ENABLE();                       // õȴʱ䣬IAPһξ͹
    IAP_ERASE();                        // , ıʱ
                                        // ֻûֽڲ512ֽ/
                                        // һֽڵַַ
    IAP_ADDRE = (u8)(EE_address >> 16); // ַֽڣַҪıʱ͵ַ
    IAP_ADDRH = (u8)(EE_address >> 8);  // ַֽڣַҪıʱ͵ַ
    IAP_ADDRL = (u8)EE_address;         // ַֽڣַҪıʱ͵ַ
    EEPROM_Trig();                      // EEPROM
    DisableEEPROM();                    // ֹEEPROM
}

void EEPROM_write_n(u32 EE_address, u8 *DataAddress, u16 number)
{
    IAP_ENABLE(); // õȴʱ䣬IAPһξ͹
    IAP_WRITE();  // , ֽд
    do
    {
        IAP_ADDRE = (u8)(EE_address >> 16); // ͵ַֽڣַҪıʱ͵ַ
        IAP_ADDRH = (u8)(EE_address >> 8);  // ͵ַֽڣַҪıʱ͵ַ
        IAP_ADDRL = (u8)EE_address;         // ͵ַֽڣַҪıʱ͵ַ
        IAP_DATA = *DataAddress;            // ݵIAP_DATAֻݸıʱ
        EEPROM_Trig();                      // EEPROM
        EE_address++;                       // һַ
        DataAddress++;                      // һ
    } while (--number);                     // ֱ
    DisableEEPROM();
}

void Set_Buffer(Moto_Save_Dat *_moto)
{
    _moto->buffer[0] = _moto->dir;
    _moto->buffer[1] = _moto->pp;
    _moto->buffer[2] = (u8)((_moto->zero) >> 8);
    _moto->buffer[3] = (u8)(_moto->zero);
    _moto->buffer[4] = _moto->can_id;
    _moto->buffer[5] = _moto->save_ok;
}

void Get_Buffer(Moto_Save_Dat *_moto)
{
    _moto->dir = _moto->buffer[0];
    _moto->pp = _moto->buffer[1];
    _moto->zero = (u16)(_moto->buffer[2])<<8|_moto->buffer[3];
    _moto->can_id = _moto->buffer[4];
    _moto->save_ok = _moto->buffer[5];
}

#define IAP_OFFSET 0xD5FF // STC32F12K54-Ĭ0.5KEEPROMռ

char Read_Flash_Data(int addr)
{
    addr += IAP_OFFSET;
    return *(int code *)(addr);
}