#include "./H_Group/i2c.h"
#include "./H_Group/spi.h"

I2C_Message i2c_msg;
bit isda; // 豸ַ־
bit isma;
u8 addr;
u8 dat_reg[7] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}; // ܹ߸Ĵ
u8 sync_reg[1] = {0x00};                                    // 㲥״̬Ĵ
bit i2c_save_flag = 0;                                      // ַ
bit i2c_en = 0;                                             // ͬ첽־λ
u8 save_addr = 0;                                           // Ĵӻַ
bit di_di_flag = 0;                                         // ַ־
bit i2c_update = 0;                                         // i2cݴ־λ

void I2C_Init(void)
{
    I2CCFG = 0x80;                         // ʹI2Cӻģʽ
    I2CSLST = 0x00;                        // I2Cӻ״̬
    I2CSLCR = ESTAI | ERXI | ETXI | ESTOI; // ʹܴӻģʽж
    if (save_addr == 0x00)
    {
        i2c_msg.this_device_addr = 0x00;
        i2c_msg.this_reg_p = sync_reg; // ʹõļĴ
    }
    else
    {
        i2c_msg.this_device_addr = save_addr; // ǰˣлַ
        i2c_msg.this_reg_p = dat_reg;         // ʹõļĴ
    }
    i2c_msg.this_reg_addr = 0x00;     // ʼֵ
    i2c_msg.this_state = i2c_default; // Ĭ״̬޲
}

// ݽ
#define Ctrl_RW 0x80
#define Ctrl_EN 0x40
#define Ctrl_SYNC 0x20
#define Ctrl_Mode 0x18
#define Ctrl_AC 0x04
#define Ctrl_ON_OFF 0x01
#define Config_Update 0x01

void Find_Data(Moto_Config *p) // ݣз
{
    if (i2c_msg.this_state == i2c_default) // ״̬ſԽнֹб
    {
        if (i2c_msg.this_device_addr == 0x00) // ǰǹ㲥״̬
        {
            if (sync_reg[0] & Config_Update)
            {
                // ģʽٶȺλ趨
                switch (Mode)
                {
                case Speed_Mode:
                {
                    p->set_speed = (int)(dat_reg[1] << 8) | (int)(dat_reg[2]);
                }
                break;

                case Postion_Mode:
                {
                    p->set_postion = (long)(dat_reg[3] << 24) |
                                     (long)(dat_reg[4] << 16) |
                                     (long)(dat_reg[5] << 8) |
                                     (long)(dat_reg[6]);
                }
                break;
                default:
                    break;
                }
                i2c_msg.this_device_addr = save_addr;
                I2CSLADR = i2c_msg.this_device_addr;
                sync_reg[0] = 0x00; // ֹUpdate
                dat_reg[0] &= 0x9f; // ȥENSYNCֹ
            }
        }
        if (i2c_msg.this_device_addr == save_addr) // ǰͨ״̬
        {
            if (dat_reg[0] & Ctrl_SYNC) // 㲥״̬
            {
                i2c_msg.this_device_addr = 0x00;
                I2CSLADR = i2c_msg.this_device_addr;
            }
            if (dat_reg[0] & Ctrl_EN) // ͬģʽ
                i2c_en = 1;
            else
            { // 첽ģʽ
                if (dat_reg[0] & Ctrl_Mode)
                    Mode = (dat_reg[0] & Ctrl_Mode) >> 3;
                Run_Flag = (dat_reg[0] & Ctrl_ON_OFF);
            }
        }
    }

    // p->set_speed = (int)(dat_reg[1] << 8) | (int)(dat_reg[2]);
    // p->set_postion = (long)(dat_reg[3] << 24) | (long)(dat_reg[4] << 16) | (long)(dat_reg[5] << 8) | (long)(dat_reg[6]);
}

// 
u8 test_addr = 0;
u8 test_dat = 0;
u8 test_reg = 0;
u8 test_tx = 0;

void I2C_Isr() interrupt I2C_VECTOR
{
    test_addr = I2CSLADR;
    test_dat = I2CRXD;
    test_reg = I2CSLST;
    test_tx = I2CTXD;
    // Դ
    if (I2CSLST & STAIF)
    {
        I2CSLST &= ~STAIF;                     // START¼
        if (i2c_msg.this_state != i2c_default) // ڶSTARTʱλ״̬Ĵ
            i2c_msg.this_state = i2c_default;
    }
    else if (I2CSLST & RXIF)
    {
        I2CSLST &= ~RXIF; // RECV¼SLACKOΪ0
        if (i2c_msg.this_state < i2c_reg_data_recv)
            i2c_msg.this_state++;
        switch (i2c_msg.this_state)
        {
        case i2c_dev_addr_recv:
            if ((I2CRXD & 0xfe) == save_addr)
                i2c_msg.this_reg_p = dat_reg; // лݼĴ
            if ((I2CRXD & 0xfe) == 0x00)
                i2c_msg.this_reg_p = sync_reg; // л㲥Ĵ
            break;
        case i2c_reg_addr_recv:
            i2c_msg.this_reg_addr = I2CRXD;
            I2CTXD = i2c_msg.this_reg_p[i2c_msg.this_reg_addr];
            break;
        case i2c_reg_data_recv:
            i2c_msg.this_reg_p[i2c_msg.this_reg_addr] = I2CRXD; // 
            i2c_update = 1;
            break;
        default:
            break;
        }
    }
    else if (I2CSLST & TXIF)
    {
        I2CSLST &= ~TXIF; // SEND¼
//        if (I2CSLST & SLACKI)
//            I2CTXD = 0xff; // յNAKֹͣ
//        else
//            I2CTXD = i2c_msg.this_reg_p[i2c_msg.this_reg_addr++];
//        ; // յACK
    }
    else if (I2CSLST & STOIF)
    {
        I2CSLST &= ~STOIF;                // STOP¼
        i2c_msg.this_state = i2c_default; // Ĭ״̬
    }
}
